// The Valves now refresh and overwrite correctly
#include <math.h>
#include "Adafruit_ILI9341_Albert.h"

#include "SPI.h"
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"

// For the Adafruit shield, these are the default.
#define TFT_DC 13
#define TFT_CS 12
#define TFT_MOSI 11
#define TFT_CLK 10
#define TFT_RST 9
#define TFT_MISO 8

#include <TinyGPS++.h>                                      //GPS
#include <SoftwareSerial.h>

static const int RXPin = 4, TXPin = 3;                      //can change these for fianl
static const uint32_t GPSBaud = 9600;                       //DO NOT CHANGE

TinyGPSPlus gps;                                            //GPS

SoftwareSerial ss(RXPin, TXPin);
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_MOSI, TFT_CLK, TFT_RST, TFT_MISO);

#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF



#include "MPU9250.h"

MPU9250 IMU(Wire, 0x68);
int status;

float BigX = 40.900531;
float LittleX = -6.699225;
float BigY =  -0.176881;
float LittleY = -87.733024;

float Mx = 0;
float My = 0;


#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif
#define PIN 6
#define NUMPIXELS 16
Adafruit_NeoPixel strip(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
#define DELAYVAL 500

const int NNW = 1;
const int NW = 2;
const int WNW = 3;
const int W = 4;
const int WSW = 5;
const int SW = 6;
const int SSW = 7;
const int S = 8;
const int SSE = 9;
const int sE = 10;
const int ESE = 11;
const int E = 12;
const int ENE = 13;
const int NE = 14;
const int NNE = 15;
const int N = 0;

int indicator = 0;

const byte level = 10;

float Heading = 0;


int UserSetHeading = 0;

int state = 1;






const int backButtonPin = 5;    //buttons
const int upButtonPin = 31;
const int downButtonPin = 30;
const int nextButtonPin = 2;

int buttonPushCounter = 0;

int backButtonState = 0;
int upButtonState = 0;
int downButtonState = 0;
int nextButtonState = 0;
int prevBackButtonState = 0;
int prevUpButtonState = 0;
int prevDownButtonState = 0;
int prevNextButtonState = 0;


//unsigned long startTime = 0;
//int Q = 0;


void setup() {
#if defined(__AVR_ATtiny85__) && (F_CPU == 16000000)
  clock_prescale_set(clock_div_1);
#endif


  strip.begin();
  strip.show();

  Serial.begin(9600);
  Serial1.begin(9600);        //GPS
  Serial.println("Test!");
  tft.setRotation(180);
  tft.begin();
  tft.setRotation(3);
  tft.fillScreen(BLACK);

  tft.setCursor(65, 30);         //Print "Heading:" Text
  tft.setTextColor(WHITE);
  tft.setTextSize(4);
  tft.print("Heading:");

  tft.setCursor(65, 130);          //Print "USER Heading:" text
  tft.setTextColor(BLUE);
  tft.setTextSize(2);
  tft.print(" USER Heading:");

  tft.setCursor(30, 200);         //Print "LAT:" Text
  tft.setTextColor(YELLOW);
  tft.setTextSize(1);
  tft.print("LAT:");

  tft.setCursor(150, 200);         //Print "LNG:" Text
  tft.setTextColor(YELLOW);
  tft.setTextSize(1);
  tft.print("  LNG:");


  status = IMU.begin();
}
void loop(void) {
  prevBackButtonState = backButtonState;
  backButtonState = digitalRead(backButtonPin);
  prevUpButtonState = upButtonState;
  upButtonState = digitalRead(upButtonPin);
  prevDownButtonState = downButtonState;
  downButtonState = digitalRead(downButtonPin);
  prevNextButtonState = nextButtonState;
  nextButtonState = digitalRead(nextButtonPin);

  





  while (Serial1.available() > 0)               // check for gps data
    if (gps.encode(Serial1.read()))               // encode gps data
      displayInfo();

  if (millis() > 100 && gps.charsProcessed() < 10)
  {
    Serial.println(F("No GPS detected: check wiring."));
    //LCD error and please reset     
    while (true);
  }

  switch (state) {
    case 1:                                                                             //DO NOTHING MODE
      //Q = 0;
      //startTime = millis();
      buttonPushCounter = 0;
      
      Serial.print("Loading....");
      tft.setCursor(130, 150);          //Print "USER Heading:" text
      tft.setTextColor(BLACK, BLACK);
      tft.setTextSize(2);
      tft.print("0000");
     
      tft.setCursor(130, 150);          //Print "USER Heading:" text
      tft.setTextColor(BLACK, BLACK);
      tft.setTextSize(2);
      tft.print("9999");

      tft.setCursor(130, 150);          //Print "USER Heading:" text
      tft.setTextColor(BLACK, BLACK);
      tft.setTextSize(2);
      tft.print("5555");

      //if (millis() - startTime >= 10000) {
        //Q = 1;
      //}
      delay(10000);
      //if(Q = 1){
      state = 2;
      //}
      //non blocking delay.
      //maybe add an lcd count down.
      
                                                                        //ADVANCES TO COMPASS MODE AFTER 10 SECONDS

     break;
    case 2:                                     //COMPASS MODE


      if (upButtonState == HIGH)// && prevUpButtonState == LOW)
      {
        buttonPushCounter++;
        Serial.println(buttonPushCounter);
        //delay(50);
      }

      if (downButtonState == HIGH)// && prevDownButtonState == LOW)
      {
        buttonPushCounter--;
        Serial.println(buttonPushCounter);
        //delay(50);
      }
      if (buttonPushCounter < 0) {
        buttonPushCounter = 359;
      }
      if (buttonPushCounter > 359) {
        buttonPushCounter = 0;
      }

      tft.setCursor(130, 150);          //Print "USER Heading:" text
      tft.setTextColor(RED, BLACK);
      tft.setTextSize(2);
      tft.print(buttonPushCounter);


      if (IMU.getAccelX_mss() >= 3 || IMU.getAccelY_mss() >= 3) {                     //GPS COMPASS MODE
        Heading = 360 - gps.course.deg();
        Serial.print("Heading = ");
        Serial.println(gps.course.deg());
        tft.setCursor(150, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
        tft.setTextColor(CYAN, BLACK);
        tft.setTextSize(3);
        tft.print( gps.course.deg());
      }
     if (IMU.getAccelX_mss() < 3 && IMU.getAccelY_mss() < 3) {                     //MAGNETOMETER COMPASS MODE
        if (My > 0 && Mx > 0){                                      //270 to 360
          Heading = 360 - ( 270 + atan2(Mx, My) * 180 / 3.14159);  //CONVERTS FROM NEGATIVE VECOTR TO POSITIVE HEADING ANGLE
          Serial.print("Heading = ");
          Serial.print( 270 + atan2(Mx, My) * 180 / 3.14159);
          Serial.print(" My = ");
          Serial.print( My );
          Serial.print(" Mx = ");
          Serial.print( Mx );
          tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
          tft.setTextColor(YELLOW, BLACK);
          tft.setTextSize(3);
          tft.print( 270 + atan2(Mx, My) * 180 / 3.14159);
        }
        if (Mx > 0 && My < 0) {                                 //0 to 90
          Heading = 360 - (-90 + atan2(Mx, My) * 180 / 3.14159);        //POSITIVE VECTOR STATUS
          Serial.print("Heading = ");
          Serial.print( -90 + atan2(Mx, My) * 180 / 3.14159);
          Serial.print(" My = ");
          Serial.print( My );
          Serial.print(" Mx = ");
          Serial.print( Mx );
          tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
          tft.setTextColor(YELLOW, BLACK);
          tft.setTextSize(3);
          tft.print( -90 + atan2(Mx, My) * 180 / 3.14159);
        }
        if (Mx < 0 && My < 0){                                    //90 to 180
          Heading = 360 - ( abs(atan2(My, Mx)*180/3.14159));
          Serial.print("Heading = ");
          Serial.print( abs(atan2(My, Mx) * 180 / 3.14159));
          Serial.print(" My = ");
          Serial.print( My );
          Serial.print(" Mx = ");
          Serial.print( Mx );
          tft.setCursor(120, 70);
          tft.setTextColor(YELLOW, BLACK);
          tft.setTextSize(3);
          tft.print( abs(atan2(My, Mx)*180/3.14159));
        }
        if (Mx < 0 && My > 0){                                    //180 to 270
          Heading = 360 - ( 270 + atan2(Mx, My)*180/3.14159);
          Serial.print("Heading = ");
          Serial.print( 270 + atan2(Mx, My) * 180 / 3.14159);
          Serial.print(" My = ");
          Serial.print( My );
          Serial.print(" Mx = ");
          Serial.print( Mx );
           tft.setCursor(120, 70);
          tft.setTextColor(YELLOW, BLACK);
          tft.setTextSize(3);
          tft.print( 270 + atan2(Mx, My)*180/3.14159);
        }

      }
      if (nextButtonState == HIGH && prevNextButtonState == LOW) {  //  Put button to change state GOES HERE....i.e.
        state = 3;                                                    //Put button to change state GOES HERE....i.e.
       UserSetHeading =  buttonPushCounter; 
        break;
      }                                           //                                        if(upButtonState == HIGH && prevUpButtonState == LOW){
      //                                                           state = 3;
      break;
    case 3:               //HEADING TRACKING MODE

      
      if (IMU.getAccelX_mss() >= 3 || IMU.getAccelY_mss() >= 3) {                           //GPS HEADING TRACKING
        if (gps.course.deg() > UserSetHeading) {                                              //IF GPS HEADING IS LARGER THAN USER INPUT, WILL GIVE A POSITIVE ANGLE
          Heading = 360 - gps.course.deg() + UserSetHeading;
          Serial.print("Heading = ");
          Serial.print(gps.course.deg());
          tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
          tft.setTextColor(CYAN, BLACK);
          tft.setTextSize(3);
          tft.print( gps.course.deg());
        }
        else {
          Heading = UserSetHeading - gps.course.deg();                                        //IF USER HEADING IS LARGER THAN GPS, NO CONVERSION IS NECESSARY
          Serial.print("Heading = ");
          Serial.print(gps.course.deg());
          tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
          tft.setTextColor(CYAN, BLACK);
          tft.setTextSize(3);
          tft.print( gps.course.deg());
        }
      }

      tft.setCursor(130, 150);          //Print "USER Heading:" text
      tft.setTextColor(RED, BLACK);
      tft.setTextSize(2);
      tft.print(buttonPushCounter);


      if (IMU.getAccelX_mss() < 3 && IMU.getAccelY_mss() < 3) {                                       //MAGNETOMETER HEADING TRACKING
         if (My > 0 && Mx > 0){                                                             //270 to 360
          if((270 + atan2(Mx, My) * 180 / 3.14159) > UserSetHeading) {   //HEADING IS LARGER THAN USER INPUT, CONVERTS TO POSITIVE ANGLE
            Heading = 360 - ( 270 + atan2(Mx, My) * 180 / 3.14159) + UserSetHeading;
            Serial.print("Heading = ");
            Serial.print( 270 + atan2(Mx, My) * 180 / 3.14159);
            tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( 270 + atan2(Mx, My) * 180 / 3.14159);
          }
          else {
            Heading = UserSetHeading - (270 + atan2(Mx, My) * 180 / 3.14159); //USER INPUT IS LARGER THAN HEADING...ALL IS WELL
            Serial.print("Heading = ");
            Serial.print( 270 + atan2(Mx, My) * 180 / 3.14159);
            tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( 270 + atan2(Mx, My) * 180 / 3.14159);
          }
         }
         if(Mx > 0 && My < 0){                                                                    //0 to 90                                                                     
          if ((-90 + atan2(Mx, My) * 180 / 3.14159) > UserSetHeading) {                  
            Heading = 360 - (-90 + atan2(Mx, My) * 180 / 3.14159) + UserSetHeading;
            Serial.print("Heading = ");
            Serial.print(-90 + atan2(Mx, My) * 180 / 3.14159);
            tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( -90 + atan2(Mx, My) * 180 / 3.14159);
          }
          else {                                                                                                  //USER INPUT IS LARGER THAN HEADING...ALL GOOD
            Heading = UserSetHeading - (-90 + atan2(Mx, My) * 180 / 3.14159);
            Serial.print("Heading = ");
            Serial.print( -90 + atan2(Mx, My) * 180 / 3.14159);
            tft.setCursor(120, 70);         //Print "HEADING" Text ONSCREEN ONLY A TEST THE REST WILL BE PRESISTANT IN BOTH SENSOR STATES COUSRSE WILL COME FROM SENSOR STATES LATER
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( -90 + atan2(Mx, My) * 180 / 3.14159);
          }
        }
        if (Mx < 0 && My < 0){                                                                  //90 to 180
          if((abs(atan2(My, Mx)*180/3.14159)) > UserSetHeading){
            Heading = 360 - (abs(atan2(My, Mx)*180/3.14159)) + UserSetHeading;
            Serial.print("Heading = ");
            Serial.print( abs(atan2(My, Mx)*180/3.14159));
            tft.setCursor(120, 70);
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( abs(atan2(My, Mx)*180/3.14159));
          }
          else{
            Heading = UserSetHeading - ( abs(atan2(My, Mx)*180/3.14159));
            Serial.print("Heading = ");
            Serial.print( abs(atan2(My, Mx)*180/3.14159));
            tft.setCursor(120, 70);
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( abs(atan2(My, Mx)*180/3.14159));
          }
        }
        if (Mx < 0 && My > 0){                                                                 //180 to 270
          if ((270 + atan2(Mx, My)*180/3.14159) > UserSetHeading){
            Heading = 360 - (270 + atan2(Mx, My)*180/3.14159) + UserSetHeading;
            Serial.print("Heading = ");
            Serial.print( 270 + atan2(Mx, My)*180/3.14159);
            tft.setCursor(120, 70);
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( 270 + atan2(Mx, My)*180/3.14159);
          }
          else{
            Heading = UserSetHeading - (270 + atan2(Mx, My)*180/3.14159);
            Serial.print("Heading = ");
            Serial.print( 270 + atan2(Mx, My)*180/3.14159);
            tft.setCursor(120, 70);
            tft.setTextColor(MAGENTA, BLACK);
            tft.setTextSize(3);
            tft.print( 270 + atan2(Mx, My)*180/3.14159);                               
          }
        }
      }
      if (nextButtonState == HIGH && prevNextButtonState == LOW){
        //startTime = millis();
        //Q = 0;
        state = 1;                                                      
        break;
      }
      if (backButtonState == HIGH && prevBackButtonState == LOW) { 
        state = 2;                                                   
        break;
      }                                                                                                                       
      break;
  }                                
  IMU.readSensor();
//  Serial.print("ACCEL:X ");
//  Serial.print(IMU.getAccelX_mss(), 6);
//  Serial.print("\t");
//  Serial.print("ACCEL:Y ");
//  Serial.print(IMU.getAccelY_mss(), 6);
//  Serial.print("\t");
//  Serial.print("ACCEL:Z ");
//  Serial.println(IMU.getAccelZ_mss(), 6);

  //read the sensor GYRO Line 2
//  Serial.print("GYRO:X  ");
//  Serial.print(IMU.getGyroX_rads(), 6);
//  Serial.print("\t");
//  Serial.print("GYRO:Y  ");
//  Serial.print(IMU.getGyroY_rads(), 6);
//  Serial.print("\t");
//  Serial.print("GYRO:Z  ");
//  Serial.println(IMU.getGyroZ_rads(), 6);


  Serial.print("MAG:X  ");
  Serial.print(IMU.getMagX_uT(), 6);
  Serial.print("\t");
  Serial.print("MAG:Y  ");
  Serial.print(IMU.getMagY_uT(), 6);
  Serial.print("\t");
  Serial.print("MAG:Z  ");
  Serial.println(IMU.getMagZ_uT(), 6);

Mx = (((IMU.getMagX_uT())*2)/(BigX - LittleX))-((BigX + LittleX)/(BigX - LittleX));
My = (((IMU.getMagY_uT())*2)/(BigY - LittleY))-((BigY + LittleY)/(BigY - LittleY));

//  Serial.print("\t");
//  Serial.println(IMU.getTemperature_C(), 6);
  //delay(100);

  setIndicator();
  showIndicator();
  //delay(50);


}


void setIndicator() {
  if ((Heading >= 11.25) && (Heading < 101.25)); {
    if ((Heading >= 11.25) && (Heading < 33.75)) {
      indicator = NNE;
    }
    if ((Heading >= 33.75) && (Heading < 56.25)) {
      indicator = NE;
    }
    if ((Heading >= 56.25) && (Heading < 78.75)) {
      indicator = ENE;
    }
    if ((Heading >= 78.75) && (Heading < 101.25)) {
      indicator = E;
    }
  }
  if ((Heading >= 101.25) && (Heading < 191.25)) {
    if ((Heading >= 101.25) && (Heading < 123.75)) {
      indicator = ESE;
    }
    if ((Heading >= 123.75) && (Heading < 146.25)) {
      indicator = SE;
    }
    if ((Heading >= 146.25) && (Heading < 168.75)) {
      indicator = SSE;
    }
    if ((Heading >= 168.75) && (Heading < 191.25)) {
      indicator = S;
    }
  }
  if ((Heading < 281.25) && (Heading > 191.25)) {
    if ((Heading >= 191.25) && (Heading < 213.75)) {
      indicator = SSW;
    }
    if ((Heading >= 213.75) && (Heading < 236.25)) {
      indicator = SW;
    }
    if ((Heading >= 236.25) && (Heading < 258.75)) {
      indicator = WSW;
    }
    if ((Heading >= 258.75) && (Heading < 281.25)) {
      indicator = W;
    }
  }
  if ((Heading >= 281.25) || (Heading < 11.25)) {
    if ((Heading >= 281.25) && (Heading < 303.75)) {
      indicator = WNW;
    }
    if ((Heading >= 303.75) && (Heading < 326.25)) {
      indicator = NW;
    }
    if ((Heading >= 326.25) && (Heading < 348.75)) {
      indicator = NNW;
    }
    if ((Heading >= 348.75) || (Heading < 11.25)) {
      indicator = N;
    }
  }
}
void showIndicator() {



  if (indicator == 0) {
    strip.setPixelColor(0, 0, 50, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(0, 0, 0, 0);
    strip.show();
  }
  if (indicator == 1) {
    strip.setPixelColor(1, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(1, 0, 0, 0);
    strip.show();
  }
  if (indicator == 2) {
    strip.setPixelColor(2, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(2, 0, 0, 0);
    strip.show();
  }
  if (indicator == 3) {
    strip.setPixelColor(3, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(3, 0, 0, 0);
    strip.show();
  }
  if (indicator == 4) {
    strip.setPixelColor(4, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(4, 0, 0, 0);
    strip.show();
  }
  if (indicator == 5) {
    strip.setPixelColor(5, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(5, 0, 0, 0);
    strip.show();
  }
  if (indicator == 6) {
    strip.setPixelColor(6, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(6, 0, 0, 0);
    strip.show();
  }
  if (indicator == 7) {
    strip.setPixelColor(7, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(7, 0, 0, 0);
    strip.show();
  }
  if (indicator == 8) {
    strip.setPixelColor(8, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(8, 0, 0, 0);
    strip.show();
  }
  if (indicator == 9) {
    strip.setPixelColor(9, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(9, 0, 0, 0);
    strip.show();
  }
  if (indicator == 10) {
    strip.setPixelColor(10, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(10, 0, 0, 0);
    strip.show();
  }
  if (indicator == 11) {
    strip.setPixelColor(11, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(11, 0, 0, 0);
    strip.show();
  }
  if (indicator == 12) {
    strip.setPixelColor(12, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(12, 0, 0, 0);
    strip.show();
  }
  if (indicator == 13) {
    strip.setPixelColor(13, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(13, 0, 0, 0);
    strip.show();
  }
  if (indicator == 14) {
    strip.setPixelColor(14, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(14, 0, 0, 0);
    strip.show();
  }
  if (indicator == 15) {
    strip.setPixelColor(15, 50, 0, 0);
    strip.show();
  }
  else {
    strip.setPixelColor(15, 0, 0, 0);
    strip.show();
  }
}

void displayInfo()
{
  Serial.print(F("Location: "));
  if (gps.location.isValid())
  {
    Serial.print(F("Lat:"));
    Serial.print(gps.location.lat(), 6); //for screen use var: to display this value

    tft.setCursor(55, 200);         //Print "LAT DATA" Text ONSCREEN
    tft.setTextColor(GREEN, BLACK);
    tft.setTextSize(1);
    tft.print( gps.location.lat(), 6);

    Serial.print(F("         "));
    Serial.print(F("Lng:"));
    Serial.print(gps.location.lng(), 6); //for screen use var: to display this value

    tft.setCursor(189, 200); //Print "LNG DATA" Text ONSCREEN

    tft.setTextColor(GREEN , BLACK);
    tft.setTextSize(1);
    tft.print( gps.location.lng(), 6);

    Serial.print(F("       "));
    Serial.print(F("Course  "));
    Serial.print(gps.course.deg());      //this will be 0.00 if not moving //for screen use var: to display this value



    Serial.println();
    delay(200);
  }

}
